/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.1 by edhill, Sat Aug 16 14:01:08 2003 UTC revision 1.13 by edhill, Fri Oct 10 18:38:57 2003 UTC
# Line 8  Line 8 
8  #   modified by aja 01/00  #   modified by aja 01/00
9  #   rewritten in bash by eh3 08/03  #   rewritten in bash by eh3 08/03
10    
11    # Search for particular CPP #cmds associated with packages
12    # usage: test_for_package_in_cpp_options CPP_file package_name
13    test_for_package_in_cpp_options() {
14        cpp_options=$1
15        pkg=$2
16        grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1
17        RETVAL=$?
18        if test "x${RETVAL}" = x0 ; then
19            echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"
20            exit 99
21        fi
22        grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1
23        RETVAL=$?
24        if test "x${RETVAL}" = x0 ; then
25            echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"
26            exit 99
27        fi
28        grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1
29        RETVAL=$?
30        if test "x${RETVAL}" = x0 ; then
31            echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"
32            exit 99
33        fi
34        grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1
35        RETVAL=$?
36        if test "x${RETVAL}" = x0 ; then
37            echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"
38            exit 99
39       fi
40    }
41    
42    # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
43    # the package list.
44    expand_pkg_groups() {
45        new_packages=
46        PKG_GROUPS=$ROOTDIR"/pkg/pkg_groups"
47        if test -r $PKG_GROUPS ; then
48            cat $PKG_GROUPS | sed -e 's/#.*$//g' | sed -e 's/:/ : /g' > ./p1.tmp
49            cat ./p1.tmp | awk '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp
50            matched=0
51            for i in $PACKAGES ; do
52                line=`grep "^ *$i" ./p2.tmp`
53                RETVAL=$?
54                if test "x$RETVAL" = x0 ; then
55                    matched=1
56                    replace=`echo $line | awk '{ $1=""; $2=""; print $0 }'`
57                    echo "    replacing \"$i\" with: $replace"
58                    new_packages="$new_packages $replace"
59                else
60                    new_packages="$new_packages $i"
61                fi
62            done
63            PACKAGES=$new_packages
64            rm -f ./p[1,2].tmp
65        else
66            echo "Warning: can't read package groups definition file: $PKG_GROUPS"
67        fi
68    }
69    
70  # Guess possible config options for this host  # Guess possible config options for this host
71  find_possible_configs()  {  find_possible_configs()  {
72    
73      p_PLATFORM=`uname`"-"`uname -m`      tmp1=`uname`"_"`uname -m`
74      echo "The platform appears to be:"      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
75      echo "  "$p_PLATFORM      PLATFORM=`echo $tmp2 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
76        OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
77      p_LN=      echo "  The platform appears to be:  $PLATFORM"
78    #     if test "x$OFLIST" = x ; then
79    #       echo "  No pre-defined options files were found matching this platform"
80    #       echo "  but examples for other platforms can be found in:"
81    #       echo "    $ROOTDIR/tools/build_options"
82    #     else
83    #       echo "  Options files (located in $ROOTDIR/tools/build_options) that"
84    #       echo "  may work with this machine are:"
85    #       for i in $OFLIST ; do
86    #           echo "    $i"
87    #       done
88    #     fi
89        
90      echo "test" > test      echo "test" > test
91      ln -s ./test link      ln -s ./test link
92      RETVAL=$?      RETVAL=$?
93      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
94          p_LN="ln -s"          LN="ln -s"
95        else
96            echo "Error: \"ln -s\" does not appear to work on this system!"
97            echo "  For help, please contact <MITgcm-support@mitgcm.org>."
98            exit 1
99      fi      fi
100      rm -f test link      rm -f test link
101    
102      p_CPP=`which cpp`      if test "x$CPP" = x ; then
103                CPP="cpp -traditional -P"
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         p_LN="ln -s"  
104      fi      fi
     rm -f test link  
105    
106      # look for possible fortran compilers      # look for possible fortran compilers
107        tmp="$MITGCM_FC $FC g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
108      p_FC=      p_FC=
109      for c in f77 g77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95 ; do      for c in $tmp ; do
110          which $c > /dev/null 2>&1          rm -f ./hello.f ./hello
111            cat >> hello.f <<EOF
112          program hello
113          do i=1,3
114            print *, 'hello world : ', i
115          enddo
116          end
117    EOF
118            $c -o hello hello.f > /dev/null 2>&1
119          RETVAL=$?          RETVAL=$?
120          if test "x${RETVAL}" = x0 ; then          if test "x${RETVAL}" = x0 ; then
121              p_FC="$p_FC $c"              p_FC="$p_FC $c"
122          fi          fi
123      done      done
     echo "Possible FORTRAN compilers appear to be:  "  
124      if test "x${p_FC}" = x ; then      if test "x${p_FC}" = x ; then
125          echo "  None found!!!"          cat 1>&2 <<EOF
126      else  
127          echo "  "$p_FC  Error: No Fortran compilers were found in your path.  Please specify one using:
128      fi  
129        1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
130        2) a command-line option (eg. "-fc NAME"), or
131        3) the MITGCM_FC environment variable.
132    
     # look for possible MPI libraries  
     mpi_libs=  
     mpi_fort=`which mpif77 2>/dev/null`  
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         cat >>test.f <<EOF  
       PROGRAM HELLO  
       DO 10, I=1,10  
       PRINT *,'Hello World'  
    10 CONTINUE  
       STOP  
       END  
133  EOF  EOF
134          eval "$mpi_fort -showme test.f > out"          exit 1
135          RETVAL=$?      else
136          if test "x${RETVAL}" = x0 ; then          echo "  The possible FORTRAN compilers found in your path are:"
137              a=`cat out`          echo "   "$p_FC
138              for i in $a ; do          if test "x$FC" = x ; then
139                  case $i in              FC=`echo $p_FC | awk '{print $1}'`
                     -*)  
                         mpi_libs="$mpi_libs $i" ;;  
                 esac  
             done  
             echo "The MPI libs appear to be:"  
             echo "  "$mpi_libs  
140          fi          fi
         rm -f test.f out  
141      fi      fi
142    
143  }      for i in $p_FC ; do
144            p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
145            if test -r $p_OF ; then
146                OPTFILE=$p_OF
147                echo "  The options file:  $p_OF"
148                echo "    appears to match so we'll use it."
149                break
150            fi
151        done
152        if test "x$OPTFILE" = x ; then
153            cat 1>&2 <<EOF
154    
155  parse_options()  {  Error: No options file was found in:  $ROOTDIR/tools/build_options/
156      that matches this platform ("$PLATFORM") and the compilers found in
157      your path.  Please specify an "optfile" using:
158    
159      ac_prev=      1) the command line (eg. "-optfile=path/to/OPTFILE"), or
160      for ac_option in "${OPTIONS[@]}" ; do      2) the MITGCM_OF environment variable.
161    
162      If you need help, please contact the developers at <MITgcm-support@mitgcm.org>.
163    
164    EOF
165            exit 1
166        fi
167        
168    #     # look for possible MPI libraries
169    #     mpi_libs=
170    #     mpi_fort=`which mpif77 2>/dev/null`
171    #     RETVAL=$?
172    #     if test "x${RETVAL}" = x0 ; then
173    #       cat >>test.f <<EOF
174    #       PROGRAM HELLO
175    #       DO 10, I=1,10
176    #       PRINT *,'Hello World'
177    #    10 CONTINUE
178    #       STOP
179    #       END
180    # EOF
181    #       eval "$mpi_fort -showme test.f > out"
182    #       RETVAL=$?
183    #       if test "x${RETVAL}" = x0 ; then
184    #           a=`cat out`
185    #           for i in $a ; do
186    #               case $i in
187    #                   -*)
188    #                       mpi_libs="$mpi_libs $i" ;;
189    #               esac
190    #           done
191    #           echo "The MPI libs appear to be:"
192    #           echo "  "$mpi_libs
193    #       fi
194    #       rm -f test.f out
195    #     fi
196    
         # echo "ac_option = :$ac_option:"  
           
         # If the previous option needs an argument, assign it.  
         if test -n "$ac_prev"; then  
             eval "$ac_prev=\$ac_option"  
             ac_prev=  
             continue  
         fi  
           
         ac_optarg=`expr "x$ac_option" : 'x[^=]*=\(.*\)'`  
           
         case $ac_option in  
               
             -help | --help | -h | --h)  
                 usage ;;  
               
             -nooptfile | --nooptfile)  
                 OPTFILE="NONE" ;;  
             -optfile | --optfile | -of | --of)  
                 ac_prev=optfile ;;  
             -optfile=* | --optfile=* | -of=* | --of=*)  
                 OPTFILE=$ac_optarg ;;  
               
             -pdepend | --pdepend)  
                 ac_prev=pdepend ;;  
             -pdepend=* | --pdepend=*)  
                 PDEPEND=$ac_optarg ;;  
               
             -pdefault | --pdefault)  
                 ac_prev=pdefault ;;  
             -pdefault=* | --pdefault=*)  
                 PDEFAULT=$ac_optarg ;;  
               
             -makefile | -ma)  
                 ac_prev=makefile ;;  
             --makefile=* | -ma=*)  
                 MAKEFILE=$ac_optarg ;;  
               
             -platform | --platform | -pl | --pl)  
                 ac_prev=platform ;;  
             -platform=* | --platform=* | -pl=* | --pl=*)  
                 PLATFORM=$ac_optarg ;;  
   
             -rootdir | --rootdir | -rd | --rd)  
                 ac_prev=rootdir ;;  
             -rootdir=* | --rootdir=* | -rd=* | --rd=*)  
                 ROOTDIR=$ac_optarg ;;  
               
             -mods | --mods | -mo | --mo)  
                 ac_prev=mods ;;  
             -mods=* | --mods=* | -mo=* | --mo=*)  
                 MODS=$ac_optarg ;;  
               
             -disable | --disable)  
                 ac_prev=disable ;;  
             -disable=* | --disable=*)  
                 DISABLE=$ac_optarg ;;  
               
             -enable | --enable)  
                 ac_prev=enable ;;  
             -enable=* | --enable=*)  
                 ENABLE=$ac_optarg ;;  
               
             -noopt | --noopt)  
                 ac_prev=noopt ;;  
             -noopt=* | --noopt=*)  
                 NOOPT=$ac_optarg ;;  
               
 #           -cpp | --cpp)  
 #               ac_prev=cpp ;;  
 #           -cpp=* | --cpp=*)  
 #               CPP=$ac_optarg ;;  
               
             -fortran | --fortran | -fc | --fc)  
                 ac_prev=fc ;;  
             -fc=* | --fc=*)  
                 FC=$ac_optarg ;;  
               
             -ieee | --ieee)  
                 IEEE=1 ;;  
             -noieee | --noieee)  
                 IEEE=0 ;;  
               
             -mpi | --mpi)  
                 MPI=1 ;;  
             -nompi | --nompi)  
                 MPI=0 ;;  
               
             -jam | --jam)  
                 JAM=1 ;;  
             -nojam | --nojam)  
                 JAM=0 ;;  
               
             -*)  
                 echo "Error: unrecognized option: "$ac_option  
                 usage  
                 ;;  
               
             *)  
                 echo "Error: unrecognized argument: "$ac_option  
                 usage  
                 ;;  
               
         esac  
           
     done  
197  }  }
198    
199  #  Parse the package dependency information  #  Parse the package dependency information
# Line 210  get_pdepend_list()  { Line 213  get_pdepend_list()  {
213    
214  #  Explain usage  #  Explain usage
215  usage()  {  usage()  {
216      echo ""      echo
217      echo "Usage: "$0" [OPTIONS]"      echo "Usage: "$0" [OPTIONS]"
218      echo "  where [OPTIONS] can be:"$'\n'      echo "  where [OPTIONS] can be:"
219        echo
220      echo "    -help | --help | -h | --h"      echo "    -help | --help | -h | --h"
221      echo "    -nooptfile | --nooptfile"      echo "    -nooptfile | --nooptfile"
222      echo "      -optfile NAME | --optfile NAME | -of NAME | --of NAME"      echo "      -optfile NAME | --optfile NAME | -of NAME | --of NAME"
# Line 221  usage()  { Line 225  usage()  {
225      echo "      -pdepend=NAME | --pdepend=NAME"      echo "      -pdepend=NAME | --pdepend=NAME"
226      echo "    -pdefault NAME | --pdefault NAME"      echo "    -pdefault NAME | --pdefault NAME"
227      echo "      -pdefault=NAME | --pdefault=NAME"      echo "      -pdefault=NAME | --pdefault=NAME"
228      echo "    -makefile NAME | -ma NAME"      echo "    -make NAME | -m NAME"
229      echo "      --makefile=NAME | -ma=NAME"      echo "      --make=NAME | -m=NAME"
230        echo "    -makefile NAME | -mf NAME"
231        echo "      --makefile=NAME | -mf=NAME"
232      echo "    -platform NAME | --platform NAME | -pl NAME | --pl NAME"      echo "    -platform NAME | --platform NAME | -pl NAME | --pl NAME"
233      echo "      -platform=NAME | --platform=NAME | -pl=NAME | --pl=NAME"      echo "      -platform=NAME | --platform=NAME | -pl=NAME | --pl=NAME"
234      echo "    -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME"      echo "    -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME"
# Line 233  usage()  { Line 239  usage()  {
239      echo "      -disable=NAME | --disable=NAME"      echo "      -disable=NAME | --disable=NAME"
240      echo "    -enable NAME | --enable NAME"      echo "    -enable NAME | --enable NAME"
241      echo "      -enable=NAME | --enable=NAME"      echo "      -enable=NAME | --enable=NAME"
242        echo "    -standarddirs NAME | --standarddirs NAME"
243        echo "      -standarddirs=NAME | --standarddirs=NAME"
244      echo "    -noopt NAME | --noopt NAME"      echo "    -noopt NAME | --noopt NAME"
245      echo "      -noopt=NAME | --noopt=NAME"      echo "      -noopt=NAME | --noopt=NAME"
246  #    echo "    -cpp NAME | --cpp NAME"  #    echo "    -cpp NAME | --cpp NAME"
# Line 241  usage()  { Line 249  usage()  {
249      echo "      -fc=NAME | --fc=NAME"      echo "      -fc=NAME | --fc=NAME"
250      echo "    -[no]ieee | --[no]ieee"      echo "    -[no]ieee | --[no]ieee"
251      echo "    -[no]mpi | --[no]mpi"      echo "    -[no]mpi | --[no]mpi"
252      echo "    -[no]jam | --[no]jam"$'\n'      echo "    -[no]jam | --[no]jam"
253      echo "  and NAME is a string such as:"$'\n'      echo
254        echo "  and NAME is a string such as:"
255        echo
256      echo "    --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'"      echo "    --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'"
257      echo "    -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'"      echo "    -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'"
258      echo "    -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'"$'\n'      echo "    -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'"
259        echo
260      echo "  which, depending upon your shell, may need to be single-quoted"      echo "  which, depending upon your shell, may need to be single-quoted"
261      echo "  if it contains spaces, dashes, or other special characters."      echo "  if it contains spaces, dashes, or other special characters."
262      exit 1      exit 1
263  }  }
264    
 # Dump all important state  
 dump_state()  {  
     fname=$1  
     echo " " > $fname  
     RETVAL=$?  
     if test "x${RETVAL}" = x ; then  
         echo "Error: cannot write to $fname"  
         exit 1  
     fi  
     echo "makefile "$makefile > $fname  
 }  
   
   
265  #eh3 # This is the generic configuration.  #eh3 # This is the generic configuration.
266  #eh3 set LN         = ( 'ln -s' )  #eh3 set LN         = ( 'ln -s' )
267  #eh3 set CPP        = ( '/lib/cpp -P' )  #eh3 set CPP        = ( '/lib/cpp -P' )
# Line 284  dump_state()  { Line 282  dump_state()  {
282  #eh3 if (! $?NOOPTFLAGS ) set NOOPTFLAGS = (  )  #eh3 if (! $?NOOPTFLAGS ) set NOOPTFLAGS = (  )
283    
284  #  Set defaults here  #  Set defaults here
285    COMMANDL="$0 $@"
286    
287  PLATFORM=  PLATFORM=
288  LN=  LN=
289  S64=  S64=
290  KPP=  KPP=
291  FC=  FC=
292  LINK=  LINK=
293    DEFINES="-DWORDLENGTH=4"
294  PACKAGES=  PACKAGES=
295  ENABLE=  ENABLE=
296  DISABLE=  DISABLE=
297  MAKEFILE=  MAKEFILE=
298  MAKEDEPEND=  MAKEDEPEND=
299  PDEPEND=  PDEPEND=
300    DUMPSTATE=t
301  PDEFAULT=  PDEFAULT=
302  OPTFILE=  OPTFILE=
303  INCLUDES=-I.  INCLUDES="-I."
304  FFLAGS=  FFLAGS=
305  FOPTIM=  FOPTIM=
306  CFLAGS=  CFLAGS=
# Line 313  MODS= Line 315  MODS=
315  TOOLSDIR=  TOOLSDIR=
316  SOURCEDIRS=  SOURCEDIRS=
317  INCLUDEDIRS=  INCLUDEDIRS=
318    STANDARDDIRS=
319    
320  PWD=`pwd`  PWD=`pwd`
321  MAKE=make  MAKE=make
# Line 320  THISHOSTNAME=`hostname` Line 323  THISHOSTNAME=`hostname`
323  THISCWD=`pwd`  THISCWD=`pwd`
324  THISDATE=`date`  THISDATE=`date`
325  MACHINE=`uname -a`  MACHINE=`uname -a`
326    EXECUTABLE=
327    EXEHOOK=
328    EXEDIR=
329    PACKAGES_CONF=
330    IEEE=
331    if test "x$MITGCM_IEEE" != x ; then
332        IEEE=$MITGCM_IEEE
333    fi
334    
335  echo $'\n'"===  Processing options files and arguments  ==="  #  The following state can be set directly by command-line switches
336  gm_local="./gm_local"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"
337    gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"
338    
339    #  The following state is not directly set by command-line switches
340    gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
341    gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
342    gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"
343    gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
344    
345    gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6"
346    
347    
348    echo
349    echo "===  Processing options files and arguments  ==="
350    gm_local="genmake_local"
351    for i in . $MODS ; do
352        if test -r $i/$gm_local ; then
353            source $i/$gm_local
354            break
355        fi
356    done
357  echo -n "  getting local config information:  "  echo -n "  getting local config information:  "
358  if test -e $gm_local ; then  if test -e $gm_local ; then
359      echo "using $gm_local"      echo "using $gm_local"
360      source $gm_local      source $gm_local
361      echo "DISABLE=$DISABLE"$'\n'"ENABLE=$ENABLE"      # echo "DISABLE=$DISABLE"
362        # echo "ENABLE=$ENABLE"
363  else  else
364      echo "none found"      echo "none found"
365  fi  fi
366    
367  #  echo "$0::$1:$2:$3:$4:$5:$6:$7:"  #  echo "$0::$1:$2:$3:$4:$5:$6:$7:"
368  OPTIONS=()  #OPTIONS=
369  n=0  #n=0
370  for i ; do  #for i ; do
371     setvar="OPTIONS[$n]='$i'"  #   echo "$i  $n"
372     #  echo "  $setvar"  #   setvar="OPTIONS[$n]='$i'"
373     eval "$setvar"  #   #  echo "  $setvar"
374     n=$(( $n + 1 ))  #   eval "$setvar"
375  done  #   n=$(( $n + 1 ))
376  parse_options  #done
377    #parse_options
378  echo "  getting OPTFILE information:  "  
379  if test "x${OPTFILE}" = x ; then  ac_prev=
380      echo "Warning: no OPTFILE specified so we'll look for possible settings"  for ac_option ; do
381      echo $'\n'"===  Searching for possible settings for OPTFILE  ==="  
382      find_possible_configs      # If the previous option needs an argument, assign it.
383  else      if test -n "$ac_prev"; then
384      if test "x$OPTFILE" = xNONE ; then          eval "$ac_prev=\$ac_option"
385          echo "    OPTFILE=NONE so we'll try to use default settings"          ac_prev=
386      else          continue
         if test -f "$OPTFILE" -a -r "$OPTFILE" ; then  
             echo "    using OPTFILE=\"$OPTFILE\""  
             source "$OPTFILE"  
             RETVAL=$?  
             if test "x$RETVAL" != x0 ; then  
                 echo -n "Error: failed to source OPTFILE \"$OPTFILE\""  
                 echo "--please check that variable syntax is bash-compatible"  
                 exit 1  
             fi  
         else  
             echo "Error: can't read OPTFILE=\"$OPTFILE\""  
             exit 1  
         fi  
     fi  
 fi  
   
 echo $'\n'"===  Setting defaults  ==="  
 echo -n "  Adding MODS directories:  "  
 for d in $MODS ; do  
     if test ! -d $d ; then  
         echo $'\n\n'"Error: MODS directory \"$d\" not found!"  
         exit 1  
     else  
         echo -n " $d"  
         SOURCEDIRS="$SOURCEDIRS $d"  
         INCLUDEDIRS="$INCLUDEDIRS $d"  
387      fi      fi
388        
389        ac_optarg=`expr "x$ac_option" : 'x[^=]*=\(.*\)'`
390        
391        case $ac_option in
392            
393            -help | --help | -h | --h)
394                usage ;;
395            
396            -nooptfile | --nooptfile)
397                OPTFILE="NONE" ;;
398            -optfile | --optfile | -of | --of)
399                ac_prev=OPTFILE ;;
400            -optfile=* | --optfile=* | -of=* | --of=*)
401                OPTFILE=$ac_optarg ;;
402            
403            -pdepend | --pdepend)
404                ac_prev=PDEPEND ;;
405            -pdepend=* | --pdepend=*)
406                PDEPEND=$ac_optarg ;;
407            
408            -pdefault | --pdefault)
409                ac_prev=PDEFAULT ;;
410            -pdefault=* | --pdefault=*)
411                PDEFAULT=$ac_optarg ;;
412            
413            -make | --make | -m | --m)
414                ac_prev=MAKE ;;
415            -make=* | --make=* | -m=* | --m=*)
416                MAKE=$ac_optarg ;;
417            
418            -makefile | --makefile | -ma | --ma)
419                ac_prev=MAKEFILE ;;
420            -makefile=* | --makefile=* | -ma=* | --ma=*)
421                MAKEFILE=$ac_optarg ;;
422            
423            -platform | --platform | -pl | --pl)
424                ac_prev=PLATFORM ;;
425            -platform=* | --platform=* | -pl=* | --pl=*)
426                PLATFORM=$ac_optarg ;;
427            
428            -rootdir | --rootdir | -rd | --rd)
429                ac_prev=ROOTDIR ;;
430            -rootdir=* | --rootdir=* | -rd=* | --rd=*)
431                ROOTDIR=$ac_optarg ;;
432            
433            -mods | --mods | -mo | --mo)
434                ac_prev=MODS ;;
435            -mods=* | --mods=* | -mo=* | --mo=*)
436                MODS=$ac_optarg ;;
437            
438            -disable | --disable)
439                ac_prev=DISABLE ;;
440            -disable=* | --disable=*)
441                DISABLE=$ac_optarg ;;
442            
443            -enable | --enable)
444                ac_prev=ENABLE ;;
445            -enable=* | --enable=*)
446                ENABLE=$ac_optarg ;;
447            
448            -standarddirs | --standarddirs)
449                ac_prev=STANDARDDIRS ;;
450            -standarddirs=* | --standarddirs=*)
451                STANDARDDIRS=$ac_optarg ;;
452    
453            -noopt | --noopt)
454                ac_prev=NOOPT ;;
455            -noopt=* | --noopt=*)
456                NOOPT=$ac_optarg ;;
457            
458    #           -cpp | --cpp)
459    #               ac_prev=cpp ;;
460    #           -cpp=* | --cpp=*)
461    #               CPP=$ac_optarg ;;
462                
463            -fortran | --fortran | -fc | --fc)
464                ac_prev=FC ;;
465            -fc=* | --fc=*)
466                FC=$ac_optarg ;;
467            
468            -ieee | --ieee)
469                IEEE=true ;;
470            -noieee | --noieee)
471                IEEE= ;;
472            
473            -mpi | --mpi)
474                MPI=true ;;
475            -nompi | --nompi)
476                MPI= ;;
477            
478            -jam | --jam)
479                JAM=1 ;;
480            -nojam | --nojam)
481                JAM=0 ;;
482            
483            -ds | --ds)
484                DUMPSTATE=t ;;
485            
486            -*)
487                echo "Error: unrecognized option: "$ac_option
488                usage
489                ;;
490            
491            *)
492                echo "Error: unrecognized argument: "$ac_option
493                usage
494                ;;
495            
496        esac
497        
498  done  done
 echo  
499    
500  if test "x$MAKEFILE" = x ; then  if test -f ./.genmakerc ; then
501      MAKEFILE="Makefile"      echo
502  fi      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
503  if test "x${PLATFORM}" = x ; then      echo "  file.  This file format is no longer supported.  Please see:"
504      PLATFORM=$p_PLATFORM      echo
505        echo "    http://mitgcm.org/devel_HOWTO/"
506        echo
507        echo "  for directions on how to setup and use the new \"genmake2\" input"
508        echo "  files and send an email to MITgcm-support@mitgcm.org if you want help."
509        echo
510  fi  fi
511    
512  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
# Line 414  if test ! -d ${ROOTDIR} ; then Line 534  if test ! -d ${ROOTDIR} ; then
534      exit 1      exit 1
535  fi  fi
536    
537    echo "  getting OPTFILE information:  "
538    if test "x${OPTFILE}" = x ; then
539        if test "x$MITGCM_OF" = x ; then
540            echo "Warning: no OPTFILE specified so we'll look for possible settings"
541            printf "\n===  Searching for possible settings for OPTFILE  ===\n"
542            find_possible_configs
543        else
544            OPTFILE=$MITGCM_OF
545        fi
546    fi
547    if test "x$OPTFILE" != xNONE ; then
548        if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
549            echo "    using OPTFILE=\"$OPTFILE\""
550            source "$OPTFILE"
551            RETVAL=$?
552            if test "x$RETVAL" != x0 ; then
553                echo -n "Error: failed to source OPTFILE \"$OPTFILE\""
554                echo "--please check that variable syntax is bash-compatible"
555                exit 1
556            fi
557            if test "x$DUMPSTATE" != xf ; then
558                cp -f $OPTFILE "genmake_optfile"
559            fi
560        else
561            echo "Error: can't read OPTFILE=\"$OPTFILE\""
562            exit 1
563        fi
564    fi
565    
566    #  Check that FC, LINK, CPP, and S64 are defined.  If not, complain
567    #  and abort!
568    if test "x$FC" = x ; then
569        cat <<EOF 1>&2
570    
571    Error: no Fortran compiler: please specify using one of the following:
572      1) within the options file ("FC=...") as specified by "-of=OPTFILE"
573      2) the "-fc=XXX" command-line option
574      3) the "./genmake_local" file
575    EOF
576        exit 1
577    fi
578    if test "x$LINK" = x ; then
579        LINK=$FC
580    fi
581    if test "x$CPP" = x ; then
582        CPP="cpp"
583    fi
584    echo "#define A a" | $CPP > test_cpp 2>&1
585    RETVAL=$?
586    if test "x$RETVAL" != x0 ; then
587        cat <<EOF 1>&2
588    
589    Error: C pre-processor "$CPP" failed the test case: please specify using:
590    
591      1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
592      2) the "./genmake_local" file
593    
594    EOF
595        exit 1
596    else
597        rm -f test_cpp
598    fi
599    if test "x$MAKEDEPEND" = x ; then
600        MAKEDEPEND=makedepend
601    fi
602    
603    printf "\n===  Setting defaults  ===\n"
604    echo -n "  Adding MODS directories:  "
605    for d in $MODS ; do
606        if test ! -d $d ; then
607            echo
608            echo "Error: MODS directory \"$d\" not found!"
609            exit 1
610        else
611            echo -n " $d"
612            SOURCEDIRS="$SOURCEDIRS $d"
613            INCLUDEDIRS="$INCLUDEDIRS $d"
614        fi
615    done
616    echo
617    
618    if test "x$MAKEFILE" = x ; then
619        MAKEFILE="Makefile"
620    fi
621    if test "x${PLATFORM}" = x ; then
622        PLATFORM=$p_PLATFORM
623    fi
624    
625  if test "x${EXEDIR}" = x ; then  if test "x${EXEDIR}" = x ; then
626      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then
627          EXEDIR=../exe          EXEDIR=../exe
# Line 433  if test ! -d ${TOOLSDIR} ; then Line 641  if test ! -d ${TOOLSDIR} ; then
641      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"
642      exit 1      exit 1
643  fi  fi
644    if test "x$S64" = x ; then
645        S64='$(TOOLSDIR)/set64bitConst.sh'
646    fi
647    
648  EXECUTABLE=${EXECUTABLE:-mitgcmuv}  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
649    
# Line 443  if test -r $ROOTDIR"/eesupp/src/Makefile Line 654  if test -r $ROOTDIR"/eesupp/src/Makefile
654      echo "  Making source files in eesupp from templates"      echo "  Making source files in eesupp from templates"
655      $MAKE -C $ROOTDIR"/eesupp/src/" > make_eesupp.errors 2>&1      $MAKE -C $ROOTDIR"/eesupp/src/" > make_eesupp.errors 2>&1
656      RETVAL=$?      RETVAL=$?
657      if test "x${RETVAL}" == "x0" ; then      if test "x${RETVAL}" = x0 ; then
658          rm -f make_eesupp.errors          rm -f make_eesupp.errors
659      else      else
660          echo "Error: problem encountered while building source files in eesupp:"          echo "Error: problem encountered while building source files in eesupp:"
# Line 452  if test -r $ROOTDIR"/eesupp/src/Makefile Line 663  if test -r $ROOTDIR"/eesupp/src/Makefile
663      fi      fi
664  fi  fi
665    
666  echo $'\n'"===  Determining package settings  ==="  printf "\n===  Determining package settings  ===\n"
667  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
668      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
669      if test -r $tmp ; then      if test -r $tmp ; then
# Line 471  echo "  getting package dependency info Line 682  echo "  getting package dependency info
682  #  Strip the comments and then convert the dependency file into  #  Strip the comments and then convert the dependency file into
683  #  two arrays: PNAME, DNAME  #  two arrays: PNAME, DNAME
684  cat $PDEPEND | sed -e 's/#.*$//g' \  cat $PDEPEND | sed -e 's/#.*$//g' \
685      | awk 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \      | awk 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \
686      > ./.pd_tmp      > ./.pd_tmp
687  RETVAL=$?  RETVAL=$?
688  if test ! "x${RETVAL}" = x0 ; then  if test ! "x${RETVAL}" = x0 ; then
# Line 481  fi Line 692  fi
692  source ./.pd_tmp  source ./.pd_tmp
693  rm -f ./.pd_tmp  rm -f ./.pd_tmp
694    
695    #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"
696    #  file should eventually be added so that, for convenience, one can
697    #  specify groups of packages using names like "ocean" and "atmosphere".
698  echo  -n "  checking default package list:  "  echo  -n "  checking default package list:  "
699  if test "x${PDEFAULT}" = x ; then  if test "x${PDEFAULT}" = x ; then
700        for i in "." $MODS ; do
701            if test -r $i"/packages.conf" ; then
702                    PDEFAULT=$i"/packages.conf"
703                    break
704            fi
705        done
706    fi
707    if test "x${PDEFAULT}" = x ; then
708      PDEFAULT="$ROOTDIR/pkg/pkg_default"      PDEFAULT="$ROOTDIR/pkg/pkg_default"
709  fi  fi
710  if test "x${PDEFAULT}" = xNONE ; then  if test "x${PDEFAULT}" = xNONE ; then
# Line 504  else Line 726  else
726          for i in $def ; do          for i in $def ; do
727              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
728          done          done
729          echo "    packages are:  $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
730            expand_pkg_groups
731            echo "    after group expansion packages are:  $PACKAGES"
732      fi      fi
733  fi  fi
734    
# Line 523  for p in $PACKAGES ; do Line 747  for p in $PACKAGES ; do
747  done  done
748  PACKAGES="$pack"  PACKAGES="$pack"
749  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
750  rm -f ./.tmp_pack  echo "" > ./.tmp_pack
751  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
752  for i in $PACKAGES ; do  for i in $PACKAGES ; do
753      if test ! -d "$ROOTDIR/pkg/$i" ; then      if test ! -d "$ROOTDIR/pkg/$i" ; then
# Line 544  echo "  applying package dependency rule Line 768  echo "  applying package dependency rule
768  ck=  ck=
769  while test "x$ck" != xtt ; do  while test "x$ck" != xtt ; do
770      i=0      i=0
771      rtot=${#PNAME[@]}      # rtot=${#PNAME[@]}
772        rtot=$nname
773      while test $i -lt $rtot ; do      while test $i -lt $rtot ; do
774    
775          #  Is $pname in the current $PACKAGES list?          #  Is $pname in the current $PACKAGES list?
776          pname=${PNAME[$i]}          #  pname=${PNAME[$i]}
777            tmp="pname=\"\$PNAME_$i\""
778            eval $tmp
779          pin="f"          pin="f"
780          for p in $PACKAGES ; do          for p in $PACKAGES ; do
781              if test "x$p" = "x$pname" ; then              if test "x$p" = "x$pname" ; then
# Line 557  while test "x$ck" != xtt ; do Line 784  while test "x$ck" != xtt ; do
784          done          done
785    
786          #  Is the DNAME entry a (+) or (-) rule ?          #  Is the DNAME entry a (+) or (-) rule ?
787            tmp="dname=\"\$DNAME_$i\""
788            eval $tmp
789          plus="-"          plus="-"
790          echo "${DNAME[$i]}" | grep '^+' > /dev/null 2>&1          echo $dname | grep '^+' > /dev/null 2>&1
791          RETVAL=$?          RETVAL=$?
792          if test "x$RETVAL" = x0 ; then          if test "x$RETVAL" = x0 ; then
793              plus="+"              plus="+"
794          fi          fi
795    
796          #  Is $dname in the current $PACKAGES list?          #  Is $dname in the current $PACKAGES list?
797          dname=`echo ${DNAME[$i]} | sed -e 's/^[+-]//'`          dname=`echo $dname | sed -e 's/^[+-]//'`
798          din="f"          din="f"
799          for p in $PACKAGES ; do          for p in $PACKAGES ; do
800              if test "x$p" = "x$dname" ; then              if test "x$p" = "x$dname" ; then
# Line 634  done Line 863  done
863  # done  # done
864  # echo  # echo
865    
866  echo "  Setting package-specific CPP flags in CPP_OPTIONS.h:"  # Create a list of #define and #undef to enable/disable packages
867  CPP_OPTIONS=  PACKAGES_DOT_H=PACKAGES_CONFIG.h
868  spaths=". $SOURCEDIRS"  cat <<EOF >$PACKAGES_DOT_H".tmp"
 for i in $spaths ; do  
     try="$i/CPP_OPTIONS.h"  
     #  echo -n "    trying $try : "  
     if test -f $try -a -r $try ; then  
         echo "    found CPP_OPTIONS=\"$try\""  
         CPP_OPTIONS="$try"  
         if test "x$i" != "x." ; then  
             cp -f $CPP_OPTIONS .  
         fi  
         break  
     fi  
 done  
 if test "x$CPP_OPTIONS" = x ; then  
     echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"  
     exit 1  
 fi  
 if test -e CPP_OPTIONS.h ; then  
     if test ! -e CPP_OPTIONS.h.bak ; then  
         cp -f CPP_OPTIONS.h CPP_OPTIONS.h.bak  
     fi  
     cat CPP_OPTIONS.h \  
         | awk 'BEGIN{p=1;} ($1=="C===" && $2=="GENMAKE"){p=0;} {if (p==1) print $0}' \  
         > CPP_OPTIONS.h.tmp  
 fi  
 cat <<EOF >>CPP_OPTIONS.h.tmp  
869  C=== GENMAKE v2 ===  C=== GENMAKE v2 ===
870  C  The following defines have been set by GENMAKE, so please edit  C  The following defines have been set by GENMAKE, so please do not
871  C  them only if you know what you're doing.  In general, you should  C  edit anything below these comments.  In general, you should
872  C  add or remove packages by re-running genmake with different  C  add or remove packages by re-running genmake with different
873  C  "-enable" and/or "-disable" options.  C  "-enable" and/or "-disable" options.
874    
875    #ifndef PACKAGES_H
876    #define PACKAGES_H
877    
878  C  Packages disabled by genmake:  C  Packages disabled by genmake:
879  EOF  EOF
880  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
# Line 687  for n in $names ; do Line 894  for n in $names ; do
894          done          done
895          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
896              undef=`echo "ALLOW_$n" | awk '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | awk '{print toupper($0)}'`
897              echo "#undef $undef" >> CPP_OPTIONS.h.tmp              echo "#undef $undef" >> $PACKAGES_DOT_H".tmp"
898    #           DEFINES="$DEFINES -U$undef"
899    
900  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
901              case $n in              case $n in
# Line 697  for n in $names ; do Line 905  for n in $names ; do
905                  mom_vecinv)                  mom_vecinv)
906                      DEFINES="$DEFINES -DDISABLE_MOM_VECINV"                      DEFINES="$DEFINES -DDISABLE_MOM_VECINV"
907                      ;;                      ;;
                 generic_advdiff)  
                     DEFINES="$DEFINES -DDISABLE_GENERIC_ADVDIFF"  
                     ;;  
908                  debug)                  debug)
909                      DEFINES="$DEFINES -DDISABLE_DEBUGMODE"                      DEFINES="$DEFINES -DDISABLE_DEBUGMODE"
910                      ;;                      ;;
# Line 709  for n in $names ; do Line 914  for n in $names ; do
914          fi          fi
915      fi      fi
916  done  done
917  cat <<EOF >>CPP_OPTIONS.h.tmp  cat <<EOF >>$PACKAGES_DOT_H".tmp"
918    
919  C  Packages enabled by genmake:  C  Packages enabled by genmake:
920  EOF  EOF
921  for i in $PACKAGES ; do  for i in $PACKAGES ; do
922      def=`echo "ALLOW_$i" | awk '{print toupper($0)}'`      def=`echo "ALLOW_$i" | awk '{print toupper($0)}'`
923      echo "#define $def" >> CPP_OPTIONS.h.tmp      echo "#define $def" >> $PACKAGES_DOT_H".tmp"
924    #eh3 DEFINES="$DEFINES -D$def"
925    
926  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
927      case $i in      case $i in
928          aim_v23)          aim_v23)
929              echo "#define   ALLOW_AIM" >> CPP_OPTIONS.h.tmp              echo "#define   ALLOW_AIM" >> $PACKAGES_DOT_H".tmp"
930                DEFINES="$DEFINES -DALLOW_AIM"
931                echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"
932              ;;              ;;
933      esac      esac
934  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
935    
936  done  done
937  mv -f CPP_OPTIONS.h.tmp CPP_OPTIONS.h  cat <<EOF >>$PACKAGES_DOT_H".tmp"
938    
939    #endif /* PACKAGES_H */
940    EOF
941    
942    if test ! -f $PACKAGES_DOT_H ; then
943        mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
944    else
945        cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
946        RETVAL=$?
947        if test "x$RETVAL" = x0 ; then
948            rm -f $PACKAGES_DOT_H".tmp"
949        else
950            mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
951            mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
952        fi
953    fi
954    
955  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
956  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
957  STANDARDDIRS=${STANDARDDIRS:-"eesupp model"}  if test "x$STANDARDDIRS" = x ; then
958        STANDARDDIRS="eesupp model"
959    fi
960  for d in $STANDARDDIRS ; do  for d in $STANDARDDIRS ; do
961      adr="$ROOTDIR/$d/src"      adr="$ROOTDIR/$d/src"
962      if test ! -d $adr ; then      if test ! -d $adr ; then
# Line 750  for d in $STANDARDDIRS ; do Line 976  for d in $STANDARDDIRS ; do
976      fi      fi
977  done  done
978    
979    echo " Searching for CPP_OPTIONS.h in order to warn about the presence"
980    echo " of \"#define ALLOW_PKGNAME\"-type statements:"
981    CPP_OPTIONS=
982    spaths=". $INCLUDEDIRS"
983    for i in $spaths ; do
984        try="$i/CPP_OPTIONS.h"
985        #  echo -n "    trying $try : "
986        if test -f $try -a -r $try ; then
987            echo "    found CPP_OPTIONS=\"$try\""
988            CPP_OPTIONS="$try"
989            break
990        fi
991    done
992    if test "x$CPP_OPTIONS" = x ; then
993        echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
994        exit 1
995    fi
996    # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
997    names=`ls -1 "$ROOTDIR/pkg"`
998    for n in $names ; do
999        test_for_package_in_cpp_options $CPP_OPTIONS $n
1000    done
1001    
1002    
1003  echo $'\n'"===  Creating the Makefile  ==="  echo
1004    echo "===  Creating the Makefile  ==="
1005  echo "  setting INCLUDES"  echo "  setting INCLUDES"
1006  for i in $INCLUDEDIRS ; do  for i in $INCLUDEDIRS ; do
1007      if test -d $i ; then      if ! test -d $i ; then
1008          INCLUDES="$INCLUDES -I$i"  #       INCLUDES="$INCLUDES -I$i"
1009      else  #   else
1010          echo "Warning: can't find INCLUDEDIRS=\"$i\""          echo "Warning: can't find INCLUDEDIRS=\"$i\""
1011      fi      fi
1012  done  done
# Line 766  rm -rf .links.tmp Line 1016  rm -rf .links.tmp
1016  mkdir .links.tmp  mkdir .links.tmp
1017  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
1018  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
1019  echo -n 'SRCFILES = ' > srclist.inc  echo -n 'SRCFILES = '    > srclist.inc
1020  echo -n 'CSRCFILES = ' > csrclist.inc  echo -n 'CSRCFILES = '   > csrclist.inc
1021    echo -n 'F90SRCFILES = ' > f90srclist.inc
1022  echo -n 'HEADERFILES = ' > hlist.inc  echo -n 'HEADERFILES = ' > hlist.inc
1023  alldirs=". $SOURCEDIRS $INCLUDEDIRS"  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1024  for d in $alldirs ; do  for d in $alldirs ; do
1025      deplist=      deplist=
1026      sfiles=`( cd $d; echo *.[h,c,F] )`      sfiles=`( cd $d; echo *.[h,c,F] )`
1027        sfiles=`( echo $sfiles; cd $d; echo *.F90 )`
1028      for sf in $sfiles ; do      for sf in $sfiles ; do
1029          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
1030              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
# Line 784  for d in $alldirs ; do Line 1036  for d in $alldirs ; do
1036                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
1037                          echo -n " $sf" >> srclist.inc                          echo -n " $sf" >> srclist.inc
1038                          ;;                          ;;
1039                        F90)
1040                            echo    " \\"  >> f90srclist.inc
1041                            echo -n " $sf" >> f90srclist.inc
1042                            ;;
1043                      c)                      c)
1044                          echo    " \\"  >> csrclist.inc                          echo    " \\"  >> csrclist.inc
1045                          echo -n " $sf" >> csrclist.inc                          echo -n " $sf" >> csrclist.inc
# Line 797  for d in $alldirs ; do Line 1053  for d in $alldirs ; do
1053          fi          fi
1054      done      done
1055      if test "x$deplist" != x ; then      if test "x$deplist" != x ; then
1056          echo $'\n'"#  These files are linked from $d" >> srclinks.tmp          echo "" >> srclinks.tmp
1057            echo "#  These files are linked from $d" >> srclinks.tmp
1058          echo "$deplist :" >> srclinks.tmp          echo "$deplist :" >> srclinks.tmp
1059          echo $'\t$(LN) '$d'/$@ $@' >> srclinks.tmp          printf "\t\$(LN) %s/\$@ \$@\n" $d >> srclinks.tmp
1060      fi      fi
1061  done  done
1062  rm -rf .links.tmp  rm -rf .links.tmp
1063  echo "" >> srclist.inc  echo "" >> srclist.inc
1064  echo "" >> csrclist.inc  echo "" >> csrclist.inc
1065    echo "" >> f90srclist.inc
1066  echo "" >> hlist.inc  echo "" >> hlist.inc
1067    
1068  if test -e $MAKEFILE ; then  if test -e $MAKEFILE ; then
# Line 862  MAKEDEPEND = ${MAKEDEPEND} Line 1120  MAKEDEPEND = ${MAKEDEPEND}
1120  KPP = ${KPP}  KPP = ${KPP}
1121  # Fortran compiler  # Fortran compiler
1122  FC = ${FC}  FC = ${FC}
1123    # Fortran compiler
1124    F90C = ${F90C}
1125  # Link editor  # Link editor
1126  LINK = ${LINK}  LINK = ${LINK}
1127    
# Line 875  KFLAGS2 = ${KFLAGS2} Line 1135  KFLAGS2 = ${KFLAGS2}
1135  # Optim./debug for FC  # Optim./debug for FC
1136  FFLAGS = ${FFLAGS}  FFLAGS = ${FFLAGS}
1137  FOPTIM = ${FOPTIM}  FOPTIM = ${FOPTIM}
1138    # Optim./debug for FC
1139    F90FLAGS = ${F90FLAGS}
1140    F90OPTIM = ${F90OPTIM}
1141  # Flags for CC  # Flags for CC
1142  CFLAGS = ${CFLAGS}  CFLAGS = ${CFLAGS}
1143  # Files that should not be optimized  # Files that should not be optimized
# Line 882  NOOPTFILES = ${NOOPTFILES} Line 1145  NOOPTFILES = ${NOOPTFILES}
1145  NOOPTFLAGS = ${NOOPTFLAGS}  NOOPTFLAGS = ${NOOPTFLAGS}
1146  # Flags and libraries needed for linking  # Flags and libraries needed for linking
1147  LIBS = ${LIBS} \$(XLIBS)  LIBS = ${LIBS} \$(XLIBS)
1148    # Name of the Mekfile
1149    MAKEFILE=${MAKEFILE}
1150    
1151  EOF  EOF
1152    
1153  cat srclist.inc  >> $MAKEFILE  cat srclist.inc    >> $MAKEFILE
1154  cat csrclist.inc >> $MAKEFILE  cat csrclist.inc   >> $MAKEFILE
1155  cat hlist.inc >> $MAKEFILE  cat f90srclist.inc >> $MAKEFILE
1156  echo 'F77FILES =  $(SRCFILES:.F=.f)'                    >> $MAKEFILE  cat hlist.inc      >> $MAKEFILE
1157  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o)' >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE
1158    echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE
1159    echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
1160    
1161  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
1162    
1163  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1164    
1165  .SUFFIXES:  .SUFFIXES:
1166  .SUFFIXES: .o .f .p .F .c  .SUFFIXES: .o .f .p .F .c .F90 .f90
1167    
1168  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1169  \$(EXECUTABLE): \$(OBJFILES)  \$(EXECUTABLE): \$(OBJFILES)
# Line 904  all: \$(EXECUTABLE) Line 1171  all: \$(EXECUTABLE)
1171  depend:  depend:
1172          @make links          @make links
1173          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1174            ${TOOLSDIR}/f90mkdepend >> \$(MAKEFILE)
1175    
1176  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)
1177    
1178  small_f: \$(F77FILES)  small_f: \$(F77FILES) \$(F90FILES)
1179    
1180  output.txt: \$(EXECUTABLE)  output.txt: \$(EXECUTABLE)
1181          @printf 'running ... '          @printf 'running ... '
1182          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1183    
1184  clean:  clean:
1185          -rm -rf *.o *.f *.p ${RMFILES} work.{pc,pcl}          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}
1186  Clean:  Clean:
1187          @make clean          @make clean
1188          @make cleanlinks          @make cleanlinks
1189          -rm -f Makefile.bak          -rm -f Makefile.bak genmake_state genmake_optfile make.log
1190  CLEAN:  CLEAN:
1191          @make Clean          @make Clean
1192          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
1193          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
1194          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
1195          -rm -f \$(EXECUTABLE)          -rm -f \$(EXECUTABLE) output.txt
1196    
1197  makefile:  makefile:
1198          ${0} $@          ${0} $@
# Line 936  cleanlinks: Line 1204  cleanlinks:
1204          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1205  .f.o:  .f.o:
1206          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
1207    .F90.f90:
1208            \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1209    .f90.o:
1210            \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
1211  .c.o:  .c.o:
1212          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) -c \$<
1213    
# Line 947  cleanlinks: Line 1219  cleanlinks:
1219    
1220  EOF  EOF
1221    
1222    if test "x$EXEHOOK" != x ; then
1223        printf "\nexehook:\n\t%s\n" $EXEHOOK >> $MAKEFILE
1224    fi
1225    
1226  echo "  Making list of \"exceptions\" that need \".p\" files"  echo "  Making list of \"exceptions\" that need \".p\" files"
1227  for i in $KPPFILES ; do  for i in $KPPFILES ; do
1228      base=`echo $i | sed -e 's/\/.*\///g' | sed -e 's/\..*$//g'`      base=`echo $i | sed -e 's/\/.*\///g' | sed -e 's/\..*$//g'`
# Line 965  for i in $NOOPTFILES ; do Line 1241  for i in $NOOPTFILES ; do
1241          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
1242      fi      fi
1243      echo "$base.o: $base.f" >> $MAKEFILE      echo "$base.o: $base.f" >> $MAKEFILE
1244      echo $'\t$(FC) $(FFLAGS) $(NOOPTFLAGS) -c $<' >> $MAKEFILE      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
1245  done  done
1246    
1247  echo "  Add rules for links"  echo "  Add rules for links"
# Line 973  cat srclinks.tmp >> $MAKEFILE Line 1249  cat srclinks.tmp >> $MAKEFILE
1249  rm -f srclinks.tmp  rm -f srclinks.tmp
1250    
1251  echo "  Adding makedepend marker"  echo "  Adding makedepend marker"
1252  echo $'\n\n'"# DO NOT DELETE" >> $MAKEFILE  printf "\n\n# DO NOT DELETE\n" >> $MAKEFILE
1253    
1254  echo $'\n'"===  Done  ==="  printf "\n===  Done  ===\n"
1255    
1256    
1257    #  Write the "state" for future records
1258    if test "x$DUMPSTATE" != xf ; then
1259        echo -n "" > genmake_state
1260        for i in $gm_state ; do
1261            t1="t2=\$$i"
1262            eval $t1
1263            echo "$i='$t2'" >> genmake_state
1264        done
1265    fi

Legend:
Removed from v.1.1  
changed lines
  Added in v.1.13

  ViewVC Help
Powered by ViewVC 1.1.22